

import string
table = string.maketrans("\\","/")

def escape( s ):
    return string.replace(s, u"\\" , "/" )


def write_make( filename, makedef ):
    """
    This function writes out a GNU makefile
    to the filename from the structure given

    Parameters:

    * filename (string) - The filename of the makefile to be written

    * makedef (dict) - The dict defining how the makefile should be written with the following feilds:
      * all (string) - The name of the main target

      * 'phoney' (string) - The list of all phoney targets
    
      * targets (dict) - A dict defining all the targets the key is the name of the targets and each target is a dict with the following fields:

        * deps (string) - A list of the dependencies of this target

        *
    """

    filename += ".gnu.mak"
        
    mf = file( filename, 'w' )
    write = mf.write

    # Add som validattion 

    # Write .PHONEY rule
    write('.PHONEY : ')
    write('all ')
    for t in makedef['phoney']:
        write(escape(t))
        write(' ')
    write('\n')
    write('\n')

    # Write all rule
    write('all : ')
    write( makedef['all'] )
    write('\n')
    write('\n')

    targets = makedef['targets']
    # Write the rest of the rules
    for target in targets:
        write( escape(target) )
        write(' : ')

        # write the deps
        for dep in targets[target]['deps']:
            write( escape(dep) )
            write(' ')
        write('\n')

        #write to rules
        for rule in targets[target]['rules']:
            write('\t')
            write(escape(rule))
            write('\n')
        write('\n')

    return filename


if __name__ == '__main__':
    make = { 'targets' : {'test1' : { 'deps' : [],
                                      'rules' : ['create test1']},
                          'test2' : { 'deps' : [],
                                      'rules' : ['create test2']},
                          'main' : { 'deps' : ['test1','test2'],
                                     'rules' : ['create main']},
                          },
             'all' : 'main',
             'phoney' : ['test1','test2']
             }
    print 'testing write_make createing test.mak'
    write_make( 'test.mak', make )

