# import the stuff needed to define ho our compiler works
from file_rules import option_list, option_param, option_bool, option_bool_param, option_map
from file_rules import OPTION_TYPE_HMM, OPTION_TYPE_BOOL, OPTION_TYPE_BOOL_PARAM, OPTION_TYPE_MAP, OPTION_TYPE_PARAM, OPTION_TYPE_LIST, OPTION_TYPE_IGNORE

# Guessing at this.. need to fill in the real values
DebugInformationFormatmap = {'3' : '-Zi'}

Optimizationmap = {'0' : "",
                   '1' : "/O1",
                   '2' : "/O2",
                   '3' : "/Ox"}

TargetMachinemap = { '1' : '-MACHINE:X86' }

SubSystemmap = { '1' : '-SUBSYSTEM:CONSOLE',
                 '2' : '-SUBSYSTEM:WINDOWS'}

LinkIncrementalmap = {'0': '-INCREMENTAL:NO',
                      '1': '-INCREMENTAL', }

RuntimeLibrarymap = { '2' : '-MD',
                      '3' : '-MDd' }

PrecompiledHeaderFilemap = { '2' : '-YX"stdafx.h"' }

BasicRuntimeChecksmap = { '3' : '-RTC1' }

CompileAsmap = {'0' : ''} #'-Tc' }

#Guesses http://msdn.microsoft.com/library/default.asp?url=/library/en-us/vccore/html/vcgrfgeneralpropertypagefile.asp
# I reckon this specifies which tools to run
# and which libraries to link against? I can't find a refernec in the vcproj file?

ConfigurationTypemap = { '0' : '',
    '1' : ' odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib',
                         '2' : ' /DLL kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib',
                         '3' : 'NMakefile',
                         '4' : 'Static library',
                         }



rules = {'VCCLCompilerTool'   : { 'pre' : 'cl.sh ' ,
                                  'post' : ' -c ',
                                  'objpath': 'ObjectFile',
                                  'objext' : 'obj',
                                  'Name': {'type' : OPTION_TYPE_IGNORE },
                                  'BasicRuntimeChecks' :{ 'type' : OPTION_TYPE_MAP,
                                                          'map' :BasicRuntimeChecksmap
                                                          },
                                  'AdditionalOptions' : {'type' : OPTION_TYPE_PARAM,
                                                         'flag' : '',
                                                         },
                                  'PrecompiledHeaderFile': {'type' : OPTION_TYPE_PARAM,
                                                            'flag' : '-Fp',
                                                            },
                                  'EnableFunctionLevelLinking' : { 'type' : OPTION_TYPE_BOOL,
                                                                   'flag' : '-Gy'
                                                                   },
                                  'StringPooling': { 'type' : OPTION_TYPE_BOOL,
                                                                   'flag' : '-Gf'
                                                                   },
                                  # Not sure about this one
                                  'InlineFunctionExpansion': { 'type' : OPTION_TYPE_BOOL,
                                                               'flag' : '-Ob1'
                                                               },
                                  'ProgramDataBaseFileName' : {'type' : OPTION_TYPE_IGNORE },
                                  
                                  'RuntimeLibrary' : {'type' : OPTION_TYPE_MAP,
                                                      'map' : RuntimeLibrarymap,
                                                      },
                                  'AssemblerListingLocation' : {'type' : OPTION_TYPE_PARAM,
                                                                'flag' : '-Fa',
                                                                },
                                  
                                  'CompileAs' : { 'type' : OPTION_TYPE_MAP,
                                                  'map' : CompileAsmap,
                                                  },
                                  'GenerateDebugInformation' : { 'type' : OPTION_TYPE_BOOL,
                                                              'flag' : '-DEBUG'
                                                              },
                                  
                                  'AdditionalIncludeDirectories' : {'type' : OPTION_TYPE_LIST,
                                                                  'delim' : ',;',
                                                                  'flag' : ' -I',
                                                                  },
                                  'PreprocessorDefinitions' :  {'type' : OPTION_TYPE_LIST,
                                                                'delim' : ';',
                                                                'flag' : ' -D',
                                                                },
                                  'BrowseInformation' : { 'type' : OPTION_TYPE_BOOL_PARAM,
                                                          'paramname' :'ProgramDataBaseFileName',
                                                          'flag' : '-FR'
                                                          },
                                  'DebugInformationFormat' : { 'type' : OPTION_TYPE_MAP,
                                                               'map' : DebugInformationFormatmap,
                                                               },
                                  'ObjectFile' : {'type' : OPTION_TYPE_PARAM,
                                                  'flag' : '-Fo',
                                                  },
                                  'Optimization': { 'type' : OPTION_TYPE_MAP,
                                                    'map' : Optimizationmap,
                                                    },
                                  'WarningLevel' : {'type' : OPTION_TYPE_PARAM,
                                                    'flag' : '-W',
                                                    },
                                  'UsePrecompiledHeader': { 'type' : OPTION_TYPE_MAP,
                                                            'map' : PrecompiledHeaderFilemap,
                                                            },
                                  'SuppressStartupBanner' : { 'type' : OPTION_TYPE_BOOL,
                                                              'flag' : '-nologo'
                                                              },
                                  },
           'VCResourceCompilerTool' : {'pre' : 'rc ' ,
                                       'post' : '',
                                       'objpath': None,
                                       'objext' : 'res',
                                       'Name': {'type' : OPTION_TYPE_IGNORE },
                                       'PreprocessorDefinitions' :  {'type' : OPTION_TYPE_LIST,
                                                                     'delim' : ';',
                                                                     'flag' : ' -d',
                                                                     },
                                       'AdditionalIncludeDirectories' : {'type' : OPTION_TYPE_LIST,
                                                                         'delim' : ',',
                                                                         'flag' : ' -i',
                                                                         },
                                       'Culture': {'type' : OPTION_TYPE_PARAM,
                                                   'flag' : '-l',
                                                   },
                                       },
           'VCLinkerTool' : {'pre' : 'link.sh ' ,
                             'post' : '',
                             'outputkey' : 'OutputFile',
                             'Name': {'type' : OPTION_TYPE_IGNORE },
                             'AdditionalDependencies' : {'type' : OPTION_TYPE_LIST,
                                                         'delim' : ',',
                                                         'flag' : ' ',
                                                           },
                             'AdditionalLibraryDirectories' : {'type' : OPTION_TYPE_LIST,
                                                               'delim' : ',',
                                                               'flag' : ' -LIBPATH:',
                                                               },
                             'GenerateDebugInformation' : { 'type' : OPTION_TYPE_BOOL,
                                                              'flag' : '-DEBUG'
                                                              },
                             'SuppressStartupBanner' : { 'type' : OPTION_TYPE_BOOL,
                                                         'flag' : '-NOLOGO'
                                                         },
                             'BaseAddress': {'type' : OPTION_TYPE_PARAM,
                                             'flag' : '-BASE:',
                                             },
                             'LinkIncremental' : { 'type' : OPTION_TYPE_MAP,
                                                   'map' : LinkIncrementalmap,
                                                   },
                             'OutputFile' : {'type' : OPTION_TYPE_PARAM,
                                             'flag' : '-OUT:',
                                             },
                             
                             'ProgramDatabaseFile' :  {'type' : OPTION_TYPE_PARAM,
                                                       'flag' : '-PDB:',
                                                       },
                             'TargetMachine' : { 'type' : OPTION_TYPE_MAP,
                                                 'map' : TargetMachinemap,
                                                 },
                             'SubSystem' : { 'type' : OPTION_TYPE_MAP,
                                             'map' : SubSystemmap,
                                             },
                             'IgnoreDefaultLibraryNames' : { 'type' : OPTION_TYPE_LIST,
                                                             'delim' : ',',
                                                             'flag' : '-NODEFAULTLIB:'
                                                             },
                             'ImportLibrary' : {'type' : OPTION_TYPE_PARAM,
                                                'flag' : '-IMPLIB:',
                                                },
                             },
         'VCCustomBuildTool' : { 'Name': {'type' : OPTION_TYPE_IGNORE },
                                 'outputkey' : 'Outputs',
                                 'CommandLine' :{'type' : OPTION_TYPE_PARAM,
                                                 'flag' : '',
                                                 },
                                 'Outputs' : {'type' : OPTION_TYPE_IGNORE },
                                 },
         'VCNMakeTool' : {'pre' : '' ,
                          'post' : '',
                          'outputkey' : 'Output',
                          'BuildCommandLine' : {'type' : OPTION_TYPE_PARAM,
                                                'flag' : ''},
                          'ReBuildCommandLine' : {'type' : OPTION_TYPE_IGNORE },
                          'Output': {'type' : OPTION_TYPE_IGNORE },
                          'Name': {'type' : OPTION_TYPE_IGNORE },
                          },
           }
