# Copyright 2003 Gareth Bushell
# Not an XML file just for consistancy!!


# Not really sure shat the post project bit is about???

# Add a bit to allow the ignoreing of targets eg:- _ssl _bsddb..\py

import sys
import os.path


def read_project_deps( f ):
    deps = []
    prjdepstart = f.readline()
    if prjdepstart.find("ProjectSection(ProjectDependencies) = postProject") != -1:
        while 1:
            line =  f.readline()
            if line.find('EndProjectSection') != -1:
                break
            deps.append( line.split('=')[0].strip(' \n\t') )
    else:
        raise TypeError,"Damn"
    return deps
    

def read_projects( f ):
    projects = {}
    while 1:
        project = {}
        prjline = f.readline()
        if prjline.find('Project') == -1:
            break
        prjstart = prjline.split(',')
        project['name'] = prjstart[0].split('=')[1].strip(' "\n')
        project['file'] = prjstart[1].strip(' "\n')
        project['id'] = prjstart[2].strip(' "\n')
        project['deps'] = read_project_deps( f )
        prjend = f.readline()
        if prjend.find('EndProject') == -1:
            raise TypeEror,"Hmm"
        projects[project['id']] = project
    return projects


def read_sln( filename ):
    sln_file = file( filename, 'r' )
    
    ver = sln_file.readline()
    if ver.find('Microsoft Visual Studio Solution File, Format Version 8.00') == -1:
        raise TypeError,"Invalid sln  file (maybe not this check is a bit crap)"

    projects = {}

    projects = read_projects(sln_file)

    return projects

def sln2make( projects, configname ):
    import vcproj_read
    # Generate the other make files
    makedef = {}

    projectnamelist = []
    for projectname in projects:
        projectnamelist.append( projects[projectname]['name'] )

    makedef['all'] = [] 

    makedef['phoney'] = projectnamelist

    makedef['targets'] = {}

    for projectname in projects:
        projdict = {}

        projdict['deps'] = []
        for dep in projects[projectname]['deps']:
            projdict['deps'].append( projects[dep]['name'] )

        try:
            print "Reading", projects[projectname]['file']
            makefile = vcproj_read.vcproj2make( projects[projectname]['file'], configname )
            projdict['rules'] = ["$(MAKE) -f"  + makefile]
        except IOError:
            pass# raise
        else:
            makedef['targets'][projects[projectname]['name']] = projdict
        makedef['all'].append( projects[projectname]['name'] )

    return makedef
    
    
if __name__ == "__main__":
    if len(sys.argv) < 3:
        print """
sln_read <command> <options...>
         list <filename> - Lists the valid configurations
         makemake <filename> <config> - Generates makefile(s) to build this solution in the required config
"""
        sys.exit(1)

    command = sys.argv[1]
    sln_filename = sys.argv[2]

    if command == 'list':
        # Print the valid solutions
        # sln = read_sln( sln_filename )
        print "Should get around to implementing this."
        print "Need to read in the SolutionConfiguration and ProjectConfiguration bits in GlobalSection"
        sys.exit(1)
    elif command == 'makemake':

        sln = read_sln( sln_filename )

        if len(sys.argv) < 4:
            print "Specify config"
            sys.exit(1)
            
        configname = sys.argv[3]
        
        # Write the main makefile

        # Get around to alowing you to specify either the rules and/or the makefile format
        import gnu_make
        import msvc7_rules
    
        import file_rules

        file_rules.set_rules( msvc7_rules )

        makedef = sln2make( sln, configname )

        makedef['all'] = " ".join( makedef['all'] )

        print "Writing ",os.path.splitext( sln_filename )[0] + ".gnu.mak"

        gnu_make.write_make(os.path.splitext( sln_filename )[0] , makedef )
    else:
        print "Specify Command"
        sys.exit(1)
